class TRGCObj
{
private:
  int RefCount;
public:
  int RegisterReference() { return ++RefCount; }
  int DeregisterReference()
    {
      if (RefCount > 0) --RefCount;
      return RefCount;
    }
  TRGCObj() : RefCount(0) {}
  virtual ~TRGCObj() {}
  TRGCObj(TRGCObj &notUsed) : RefCount(0) {}   
  /* copies will initially start out with 0 
     references like any other object */
};

template <class T> class TRGCRef
{
private:
  T *pointer;

  void zeropointer()
    {
      if (pointer) {
        if (pointer->DeregisterReference()==0)
          delete pointer;
        pointer=0;
      }
    }
  void setpointer(T *x)
    {
      if (pointer) zeropointer();
      if (x) {
        x->RegisterReference();
        pointer=x;
      }
    }

public:
  TRGCRef() : pointer(0) {}
  TRGCRef(T *p) : pointer(0) 
    { setpointer(p); }
  TRGCRef(TRGCRef<T> &r) : pointer(0) 
    { setpointer(r.pointer); }

  ~TRGCRef() 
    { zeropointer(); }
  
  T *getpointer() { return pointer; }
  TRGCRef<T>& operator= (TRGCRef<T> &p)
    { setpointer(p.pointer); return p; }
  TRGCRef<T>& operator= (T *x) 
    { setpointer(x); return *this; }
  int operator== (TRGCRef<T> &y) { return pointer==y.pointer; }
  T& operator* () { return (*pointer); }
  T* operator-> () { return pointer; }
};

template <class T> class TRGCRefObj : public TRGCRef<T>, public TRGCObj
{
public:  
  TRGCRefObj() : TRGCRef<T>(), TRGCObj() {}
  TRGCRefObj(T *p) : TRGCRef<T>(p), TRGCObj() {}
  TRGCRefObj(TRGCRef<T> &r) : TRGCRef<T>(r), TRGCObj() {}
  TRGCRefObj(TRGCRefObj<T> &r) : TRGCRef<T>(r.getpointer()), TRGCObj() {}
  ~TRGCRefObj() {}
};