#include <stdlib.h>
#include <stdio.h>

#include "rgc.h"

char Items[]="aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";

int itemIndex = 0;

class basetester 
{
public:
  int number;
  
  basetester() : number(itemIndex) { ++ itemIndex; }
  virtual int callme() { return 97; }
  virtual ~basetester() { if (number!=1001)
			{ Items[number]='f'; number=1001; }
  else { printf("OOPS:  Item deleted twice!!\n"); } }
};

class tester : public basetester, public virtual TRGCObj {};
 
class TRefObj : public TRGCRefObj<tester>, public basetester
{
public:  
  TRefObj() : TRGCRefObj<tester>(), basetester() { }
  TRefObj(tester *p) : TRGCRefObj<tester>(p), basetester() { }
  TRefObj(TRGCRef<tester> &r) : TRGCRefObj<tester>(r), basetester() { }
  TRefObj(TRGCRefObj<tester> &r) : TRGCRefObj<tester>(r.getpointer()),
	 basetester() { }
  TRefObj(TRefObj &r) : TRGCRefObj<tester>(r.getpointer()), basetester() {}
  ~TRefObj() {}
};

typedef TRGCRef<tester> TRef;
typedef TRGCRef<TRefObj> TRefRef;

void dotest(void)
{
  TRef a,d,e,f,g;
  TRef b(new tester());
  TRef c(b);
  a=c;
  d=new tester();
  if (a==c) {
    TRef f,g;
    f=new tester();
    g=new tester();
    e=g;
  } else printf("OOPS:  == doesn't work!\n");
  if (Items[2]!='f') printf("OOPS: Memory Not Freed\n");
  if (Items[3]!='a') printf("OOPS: Memory Freed too soon\n");
  if ((*e).number!=3) printf("OOPS: Pointer off in space!!\n");
  if (e->callme()!=97) printf("OOPS:  Pointer off in space!!\n");
  if (e->number!=3) printf("OOPS:  Pointer off in space!!\n");
  e=d;
  if (Items[3]!='f') printf("OOPS: Memory Not Freed on assignment!\n");
  f=0;
  b=0;
  if (Items[0]!='a') printf("OOPS:  Memory Freed too soon on assignment!\n");
}

void dopptest(void)
{
  TRefRef a(new TRefObj());
  TRefRef b(new TRefObj(new tester()));
  TRefRef c(new TRefObj(*b));
  TRef    x(&(**b));
  TRef    y(*b);
  TRefRef d(new TRefObj(x));
  TRefRef e(b);
}

void main(void)
{
  int i,j;
  
  dotest();
  dopptest();
  for(i=0,j=0; i < itemIndex; ++i) {
    if (Items[i]!='f')
      printf("Item %d NOT FREED!!\n",i);
    else ++j;
  }
  printf("Test Complete\n");
  printf("%d of %d items freed.\n",j,itemIndex);
}

