#include <stdlib.h>
#include <stdio.h>
#include "rgc.h"

inline void CHECKPOINT(int x) { printf("CHECKPOINT %d\n",x); }

class Trcountprinter : public TRGCObj
{
 public:    
    char identity;
    
    Trcountprinter(char id) : identity(id) 
        { printf ("Trcountprinter %c created\n",identity); }
    Trcountprinter() : identity('X') 
        { printf ("Trcountprinter %c created\n",identity); }
    ~Trcountprinter() 
        { printf ("Trcountprinter %c garbage collected\n",identity); }
    int DeregisterReference()
    {
        int i;
        i = TRGCObj::DeregisterReference();
        printf("Trcountprinter %c dereg'd, outstanding refs: %d\n",identity,i);
        return i;
    }
    int RegisterReference()
    {
       int i;
       i = TRGCObj::RegisterReference();
       printf("Trcountprinter %c reg'd, outstanding refs: %d\n",identity,i);
       return i;
    }
};

typedef TRGCRef<Trcountprinter> Prcountprinter;

Prcountprinter returnObject ()
{
    CHECKPOINT(1000);
    
    Prcountprinter  a=new Trcountprinter('A');  // a now references 'A'
    
    CHECKPOINT(1001);
    // since a is being returned, it will first be copied to whatever
    // the return value of this function is being assigned to.
    // Then it will be destroyed.  So, if the return value is being
    // assigned to a Prcountprinter, there will be momentarily two
    // references to 'A' - a, and the copy, then a will be destroyed,
    // and there will only be one, the copy.
    
    return a;
}

void myfunc()
{
    CHECKPOINT(2000);
    
    Prcountprinter z;  // z references no objects
    CHECKPOINT(2001);
    Prcountprinter b = new Trcountprinter('B');  // b references 'B'
    CHECKPOINT(2002);
    Prcountprinter m = b;  // now m references 'B' too
    CHECKPOINT(2003);
    Prcountprinter c = new Trcountprinter('C');  // c references 'C'
    
    CHECKPOINT(2004);
    c=returnObject();  // 'C' will be garbage collected
                       // c now references 'A'
                       
    CHECKPOINT(2005);
    b = 0;   // m is now only reference to 'B'
    CHECKPOINT(2006);
    c = m;   // 'A' will now be garbage collected
    CHECKPOINT(2007);
    m = z;   // c is now only reference to 'B'
    CHECKPOINT(2008);
    // on leaving function, destructors for z,b,m,c will be called,
    // decrementing ref counts for objects they point to.  Only c
    // points to an object at this point, and it is the only pointer
    // to this particular object, so the object, 'B', will be 
    // garbage collected
}
    
void main(void)
{
    CHECKPOINT(5000);
    myfunc();
    
    CHECKPOINT(5001);
    printf("\nLeaving main\n\n");
}
